var fs = require('fs');

exports.waitforfile = function(filename, first_delay, cb) { 
    return do_check_file(filename, first_delay, cb); 
};

function do_check_file(filename, first_delay, cb) {
    check_file(filename, 0, first_delay, -1, function(stat) {
	cb(stat);
    });
}

function retry_check_file(file, count, delay, prev_size, new_size, cb) {
    
    if (delay == 0) {
	delay = 5;	
    } else if (delay < 100) {
	delay = Math.round(delay * 1.618);
	if (delay > 100)
	    delay = 100;	
    } else {
	delay = Math.round(delay * 0.75);
	if (delay < 50)
	    delay = 50;	
    }
    
//    console.log('getting file ' + file + ' attempt ' + count + ' delay (' + delay + ') size : ' + new_size);
    count += 1;
    
    setTimeout(function() {
	check_file(file, count, delay, new_size, cb);
    }, delay);
}

function check_file(file, count, delay, prev_size, cb) {

    fs.stat(file, function(err, stat) {

	if (!err) {
	    /*	if (prev_size == -1) {
		count = 1;
		delay = 5;
		}*/

	    if (prev_size == stat.size && stat.size != 0) {					
		cb(stat);								
	    } else {
		retry_check_file(file, count, delay, prev_size, stat.size, cb);
	    }
	}
	else {
	    retry_check_file(file, count, delay, prev_size, -1, cb);
	}
    });
}